import './index.css';

// src/hero/index.tsx
import { useRef as useRef2, useState as useState2 } from "react";

// src/hero/BackgroundStar.tsx
import { useEffect, useRef, useState } from "react";

// src/hero/index.module.scss
var index_module_default = { "logo": "logo_c477d", "ovalBg": "ovalBg_c477d", "buttonGroup": "buttonGroup_c477d", "button": "button_c477d", "innerHero": "innerHero_c477d", "title": "title_c477d", "subtitle": "subtitle_c477d", "description": "description_c477d", "hero": "hero_c477d", "buttonPrimary": "buttonPrimary_c477d", "buttonSecondary": "buttonSecondary_c477d", "backgroundStarContainer": "backgroundStarContainer_c477d", "backgroundStar": "backgroundStar_c477d" };

// src/hero/BackgroundStar.tsx
import { jsx, jsxs } from "react/jsx-runtime";
var BackgroundStar = ({
  top,
  left,
  pageX,
  pageY,
  size
}) => {
  const ref = useRef();
  const [transformX, setTransformX] = useState(0);
  const [transformY, setTransformY] = useState(0);
  useEffect(() => {
    if (ref.current) {
      const { x, y } = ref.current.getBoundingClientRect();
      if (pageX && pageY) {
        const distanceX = pageX - x;
        const distanceY = pageY - y;
        if (Math.abs(distanceX) < 100 && Math.abs(distanceY) < 100) {
          setTransformX(distanceX);
          setTransformY(distanceY);
        } else {
          setTransformX(0);
          setTransformY(0);
        }
      }
    }
  }, [pageX, pageY]);
  return /* @__PURE__ */ jsx(
    "div",
    {
      className: index_module_default.backgroundStarContainer,
      ref,
      style: {
        top,
        left
      },
      children: /* @__PURE__ */ jsxs(
        "svg",
        {
          className: index_module_default.backgroundStar,
          style: {
            width: size,
            height: size,
            transform: `translate(${transformX}px, ${transformY}px)`
          },
          xmlns: "http://www.w3.org/2000/svg",
          width: "8",
          height: "9",
          viewBox: "0 0 8 9",
          fill: "none",
          role: "img",
          "aria-label": "star",
          children: [
            /* @__PURE__ */ jsx("title", {}),
            /* @__PURE__ */ jsx("circle", { cx: "4", cy: "4.5", r: "4", fill: "url(#paint0_radial_2202_5618)" }),
            /* @__PURE__ */ jsx("defs", { children: /* @__PURE__ */ jsxs(
              "radialGradient",
              {
                id: "paint0_radial_2202_5618",
                cx: "0",
                cy: "0",
                r: "1",
                gradientUnits: "userSpaceOnUse",
                gradientTransform: "translate(4 4.49998) scale(3.77871 4.29149)",
                children: [
                  /* @__PURE__ */ jsx("stop", { stopColor: "#FF8B00" }),
                  /* @__PURE__ */ jsx("stop", { offset: "0.38", stopColor: "#F2A65A" }),
                  /* @__PURE__ */ jsx("stop", { offset: "0.59", stopColor: "#FFB966" }),
                  /* @__PURE__ */ jsx("stop", { offset: "0.92", stopColor: "#FF8B00" })
                ]
              }
            ) })
          ]
        }
      )
    }
  );
};
var BackgroundStar_default = BackgroundStar;

// src/hero/index.tsx
import { jsx as jsx2, jsxs as jsxs2 } from "react/jsx-runtime";
var positions = [
  [91.4, 22.9],
  [36, 67.6],
  [94.1, 47.7],
  [33.8, 32.5],
  [43.1, 77.6],
  [9.8, 73.4],
  [16.1, 17.1],
  [1, 10],
  [88.3, 44.9],
  [19.3, 79],
  [28.5, 11.8],
  [94.6, 44.9],
  [53.8, 3.4],
  [41.7, 20],
  [56.9, 80.6],
  [16.4, 83.4],
  [39.4, 66.8],
  [19, 18.4],
  [25.1, 28.1],
  [18.9, 35.6],
  [32.9, 12.3],
  [21.2, 72.8],
  [83.3, 79.8],
  [71.4, 36.8],
  [62.2, 50.4],
  [45.4, 13.7],
  [61.1, 28.5],
  [18.2, 64.1],
  [40.7, 34.7],
  [87.6, 20.7],
  [78.3, 30.8],
  [84.4, 58.2],
  [74.2, 74.5],
  [12.4, 66.4],
  [68.2, 41.6]
];
var useMouseMove = () => {
  const ref = useRef2();
  const [pageX, setPageX] = useState2(null);
  const [pageY, setPageY] = useState2(null);
  const handleMove = ({ pageX: pageX2, pageY: pageY2 }) => {
    setPageX(pageX2);
    setPageY(pageY2);
  };
  return {
    ref,
    pageX,
    pageY,
    onMouseMove: handleMove
  };
};
var Hero = ({
  onClickGetStarted,
  onClickLearnMore,
  showStars = false,
  logoUrl = "https://assets.rspack.dev/rspack/rspack-logo.svg",
  title = "Rspack",
  subTitle = "The fast Rust-based web bundler",
  description = "Seamlessly replace webpack with compatible API",
  getStartedButtonText = "Get Started",
  learnMoreButtonText = "Learn More"
}) => {
  const { pageX, pageY, ref, onMouseMove } = useMouseMove();
  return /* @__PURE__ */ jsx2("section", { className: index_module_default.hero, ref, onMouseMove, children: /* @__PURE__ */ jsxs2("div", { className: index_module_default.innerHero, children: [
    showStars ? positions.map(([top, left], i) => {
      return /* @__PURE__ */ jsx2(
        BackgroundStar_default,
        {
          top: `${top}%`,
          left: `${left}%`,
          size: i / 20 + 3,
          pageX,
          pageY
        },
        i
      );
    }) : null,
    /* @__PURE__ */ jsxs2("div", { className: index_module_default.logo, children: [
      /* @__PURE__ */ jsx2("img", { src: logoUrl, alt: "logo" }),
      /* @__PURE__ */ jsx2("div", { className: index_module_default.ovalBg })
    ] }),
    /* @__PURE__ */ jsx2("h1", { className: index_module_default.title, children: /* @__PURE__ */ jsx2("span", { children: title }) }),
    /* @__PURE__ */ jsx2("p", { className: index_module_default.subtitle, children: subTitle }),
    /* @__PURE__ */ jsx2("p", { className: index_module_default.description, children: description }),
    /* @__PURE__ */ jsxs2("div", { className: index_module_default.buttonGroup, children: [
      /* @__PURE__ */ jsx2(
        "button",
        {
          className: `${index_module_default.button} ${index_module_default.buttonPrimary}`,
          type: "button",
          onClick: onClickGetStarted,
          children: getStartedButtonText
        }
      ),
      /* @__PURE__ */ jsx2(
        "button",
        {
          className: `${index_module_default.button} ${index_module_default.buttonSecondary}`,
          type: "button",
          onClick: onClickLearnMore,
          children: learnMoreButtonText
        }
      )
    ] })
  ] }) });
};
export {
  Hero
};
